module     p0_ddbar_emnmumupnebar_d15h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/WpWm/1.4/Virtual/p0
   ! _ddbar_emnmumupnebar/helicity1/d15h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emnmumupnebar_config, only: ki
   use p0_ddbar_emnmumupnebar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d15
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_emnmumupnebar_globalsl1, only: epspow
      use p0_ddbar_emnmumupnebar_kinematics
      use p0_ddbar_emnmumupnebar_abbrevh1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t34 = dotproduct(qshift, qshift)
      t35 = dotproduct(k3, qshift)
      t36 = dotproduct(k6, qshift)
      t1 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t3 = (spvak4k5(1)*qshift(1)-spvak4k5(2)*qshift(2)-spvak4k5(3)*qshift(3)-sp&
      &vak4k5(4)*qshift(4))
      t37 = dotproduct(k1, qshift)
      t38 = dotproduct(k2, qshift)
      t4 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t5 = (spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-sp&
      &vak4k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t7 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb15n32+t1*abb15n63+t2*abb15n64+t3*abb15n65+t34*abb15n54+&
         &t35*abb15n62+t36*abb15n62+t37*abb15n68+t38*abb15n75+t4*abb15n83+t1*t2*&
         &abb15n39+t1*t37*abb15n53+t1*t38*abb15n53+t1*t4*abb15n37+t1*t5*abb15n34&
         &+t1*t6*abb15n40+t1*t7*abb15n45+t2*t3*abb15n57+t2*t34*abb15n94+t2*t35*a&
         &bb15n35+t2*t36*abb15n35+t2*t37*abb15n38+t3*t34*abb15n73+t3*t37*abb15n5&
         &2+t3*t6*abb15n56+t3*t8*abb15n46+t34*t5*abb15n86+t34*t7*abb15n78+t35*t5&
         &*abb15n43+t35*t7*abb15n49+t36*t5*abb15n43+t36*t7*abb15n49+t37*t5*abb15&
         &n41+t37*t7*abb15n47+t1*t3*t6*abb15n98)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k3(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak3k1(iv1)
      t15 = spvak3k6(iv1)
      t16 = spvak4k5(iv1)
      t17 = spvak6k1(iv1)
      t18 = spvak2k1(iv1)
      t19 = spvak2k5(iv1)
      t20 = t19*abb15n76
      t21 = spvak2k6(iv1)
      t22 = t14*abb15n96
      t23 = t15*abb15n70
      t24 = spvak4k1(iv1)
      t25 = t24*abb15n84
      if(deg.eq.1) then
         numerator = (t10*abb15n50+t11*abb15n61+t12*abb15n61+t13*abb15n69+t14*ab&
         &b15n59+t15*abb15n60+t16*abb15n58+t17*abb15n44+t20*t35+t20*t36+t22*t35+&
         &t22*t36+t23*t37+t23*t38+t25*t35+t25*t36+t9*abb15n55+t1*t10*abb15n70+t1&
         &*t14*abb15n90+t1*t17*abb15n92+t1*t18*abb15n89+t1*t19*abb15n82+t1*t24*a&
         &bb15n97+t1*t9*abb15n70+t11*t2*abb15n96+t11*t5*abb15n84+t11*t7*abb15n76&
         &+t12*t2*abb15n96+t12*t5*abb15n84+t12*t7*abb15n76+t13*t2*abb15n93+t13*t&
         &3*abb15n72+t13*t5*abb15n85+t13*t7*abb15n77+t14*t3*abb15n66+t14*t34*abb&
         &15n36+t14*t37*abb15n91+t15*t2*abb15n90+t15*t4*abb15n92+t15*t5*abb15n97&
         &+t15*t6*abb15n89+t15*t7*abb15n82+t16*t2*abb15n66+t16*t34*abb15n51+t16*&
         &t37*abb15n71+t16*t6*abb15n67+t16*t8*abb15n81+t18*t3*abb15n67+t19*t34*a&
         &bb15n48+t19*t37*abb15n80+t2*t9*abb15n91+t21*t3*abb15n81+t24*t34*abb15n&
         &42+t24*t37*abb15n88+t3*t9*abb15n71+t5*t9*abb15n88+t7*t9*abb15n80+t1*t1&
         &6*t6*abb15n33+t1*t18*t3*abb15n33+t15*t3*t6*abb15n33)
         return
      end if
      t34 = d(iv1,iv2)
      t4 = spvak2k5(iv2)
      t8 = spvak3k1(iv2)
      t20 = spvak3k6(iv2)
      t22 = spvak4k1(iv2)
      t23 = spvak4k5(iv2)
      t25 = k1(iv2)
      t26 = k3(iv2)
      t27 = k6(iv2)
      t28 = qshift(iv2)
      t29 = t18*t20
      t30 = t18*t23
      t31 = spvak2k1(iv2)
      t32 = t15*t31
      t33 = t16*t31
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t34*abb15n54+t2*t34*abb15n94+t3*t34*abb15n73+t34&
         &*t5*abb15n86+t34*t7*abb15n78)+t29*abb15n40+t30*abb15n56+t32*abb15n40+t&
         &33*abb15n56+k2(iv2)*t15*abb15n53+spvak2k6(iv2)*t16*abb15n46+spvak6k1(i&
         &v2)*t15*abb15n37+t1*t30*abb15n98+t1*t33*abb15n98+t10*t20*abb15n53+t11*&
         &t22*abb15n43+t11*t4*abb15n49+t11*t8*abb15n35+t12*t22*abb15n43+t12*t4*a&
         &bb15n49+t12*t8*abb15n35+t13*t22*abb15n87+t13*t23*abb15n74+t13*t4*abb15&
         &n79+t13*t8*abb15n95+t14*t20*abb15n39+t14*t23*abb15n57+t14*t25*abb15n38&
         &+t14*t26*abb15n35+t14*t27*abb15n35+t14*t28*abb15n95+t15*t22*abb15n34+t&
         &15*t25*abb15n53+t15*t4*abb15n45+t15*t8*abb15n39+t16*t25*abb15n52+t16*t&
         &28*abb15n74+t16*t8*abb15n57+t17*t20*abb15n37+t19*t20*abb15n45+t19*t25*&
         &abb15n47+t19*t26*abb15n49+t19*t27*abb15n49+t19*t28*abb15n79+t20*t24*ab&
         &b15n34+t20*t9*abb15n53+t21*t23*abb15n46+t22*t9*abb15n41+t23*t9*abb15n5&
         &2+t24*t25*abb15n41+t24*t26*abb15n43+t24*t27*abb15n43+t24*t28*abb15n87+&
         &t29*t3*abb15n98+t3*t32*abb15n98+t4*t9*abb15n47+t8*t9*abb15n38+t15*t23*&
         &t6*abb15n98+t16*t20*t6*abb15n98)
         return
      end if
      t35 = d(iv2,iv3)
      t36 = d(iv1,iv3)
      t1 = spvak4k5(iv3)
      t2 = spvak3k6(iv3)
      t3 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k5(iv3)*t34*abb15n48+spvak3k1(iv3)*t34*abb&
         &15n36+spvak4k1(iv3)*t34*abb15n42+t1*t34*abb15n51+t14*t35*abb15n36+t16*&
         &t35*abb15n51+t19*t35*abb15n48+t22*t36*abb15n42+t23*t36*abb15n51+t24*t3&
         &5*abb15n42+t36*t4*abb15n48+t36*t8*abb15n36)+t1*t29*abb15n33+t1*t32*abb&
         &15n33+t15*t23*t3*abb15n33+t16*t2*t31*abb15n33+t16*t20*t3*abb15n33+t18*&
         &t2*t23*abb15n33)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d15:
   subroutine     reconstruct_d15(coeffs)
      use p0_ddbar_emnmumupnebar_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_15:
      coeffs%coeffs_15%c0 = derivative(czip)
      coeffs%coeffs_15%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_15%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_15%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_15%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_15%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_15%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_15%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_15%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_15%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_15%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_15%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_15%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_15%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_15%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_15%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_15%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_15%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_15%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_15%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_15%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_15%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_15%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_15%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_15%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_15%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_15%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_15%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_15%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_15%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_15%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_15%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_15%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_15%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_15%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_15:
   end subroutine reconstruct_d15
!---#] subroutine reconstruct_d15:
end module p0_ddbar_emnmumupnebar_d15h1l1d
