module     p1_uubar_emnmumupnebar_golem95h0
   use precision_golem, only: ki_gol => ki
   use p1_uubar_emnmumupnebar_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use p1_uubar_emnmumupnebar_config
   use p1_uubar_emnmumupnebar_groups, only: tensrec_info_group0
   use p1_uubar_emnmumupnebar_d15h0l1, only: numerator_d15 => numerator_golem95
   use p1_uubar_emnmumupnebar_d15h0l1d, only: reconstruct_d15
   use p1_uubar_emnmumupnebar_d16h0l1, only: numerator_d16 => numerator_golem95
   use p1_uubar_emnmumupnebar_d16h0l1d, only: reconstruct_d16
   use p1_uubar_emnmumupnebar_d18h0l1, only: numerator_d18 => numerator_golem95
   use p1_uubar_emnmumupnebar_d18h0l1d, only: reconstruct_d18
   use p1_uubar_emnmumupnebar_d19h0l1, only: numerator_d19 => numerator_golem95
   use p1_uubar_emnmumupnebar_d19h0l1d, only: reconstruct_d19
   use p1_uubar_emnmumupnebar_d50h0l1, only: numerator_d50 => numerator_golem95
   use p1_uubar_emnmumupnebar_d50h0l1d, only: reconstruct_d50
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 15:
      if (tens_rec_by_derivatives) then
         call reconstruct_d15(coeffs)
      else
         call reconstruct3(numerator_d15, coeffs%coeffs_15)
      end if
   !------#] Diagram 15:
   !------#[ Diagram 16:
      if (tens_rec_by_derivatives) then
         call reconstruct_d16(coeffs)
      else
         call reconstruct2(numerator_d16, coeffs%coeffs_16)
      end if
   !------#] Diagram 16:
   !------#[ Diagram 18:
      if (tens_rec_by_derivatives) then
         call reconstruct_d18(coeffs)
      else
         call reconstruct2(numerator_d18, coeffs%coeffs_18)
      end if
   !------#] Diagram 18:
   !------#[ Diagram 19:
      if (tens_rec_by_derivatives) then
         call reconstruct_d19(coeffs)
      else
         call reconstruct2(numerator_d19, coeffs%coeffs_19)
      end if
   !------#] Diagram 19:
   !------#[ Diagram 50:
      if (tens_rec_by_derivatives) then
         call reconstruct_d50(coeffs)
      else
         call reconstruct1(numerator_d50, coeffs%coeffs_50)
      end if
   !------#] Diagram 50:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
end module p1_uubar_emnmumupnebar_golem95h0
