module     p2_bbbar_emnmumupnebar_golem95h0
   use precision_golem, only: ki_gol => ki
   use p2_bbbar_emnmumupnebar_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use p2_bbbar_emnmumupnebar_config
   use p2_bbbar_emnmumupnebar_groups, only: tensrec_info_group0
   use p2_bbbar_emnmumupnebar_d15h0l1, only: numerator_d15 => numerator_golem95
   use p2_bbbar_emnmumupnebar_d15h0l1d, only: reconstruct_d15
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 15:
      if (tens_rec_by_derivatives) then
         call reconstruct_d15(coeffs)
      else
         call reconstruct2(numerator_d15, coeffs%coeffs_15)
      end if
   !------#] Diagram 15:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
end module p2_bbbar_emnmumupnebar_golem95h0
