module     p0_ddbar_emnmumupnebar_d16h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/WpWm/1.4/Virtual/p0
   ! _ddbar_emnmumupnebar/helicity1/d16h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emnmumupnebar_config, only: ki
   use p0_ddbar_emnmumupnebar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d16
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_ddbar_emnmumupnebar_globalsl1, only: epspow
      use p0_ddbar_emnmumupnebar_kinematics
      use p0_ddbar_emnmumupnebar_abbrevh1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      real(ki) :: t17
      real(ki) :: t18
      real(ki) :: t19
      real(ki) :: t20
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t2 = (spvak4k6(1)*qshift(1)-spvak4k6(2)*qshift(2)-spvak4k6(3)*qshift(3)-sp&
      &vak4k6(4)*qshift(4))
      t3 = (spvak4k5(1)*qshift(1)-spvak4k5(2)*qshift(2)-spvak4k5(3)*qshift(3)-sp&
      &vak4k5(4)*qshift(4))
      t4 = (spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-sp&
      &vak3k5(4)*qshift(4))
      t5 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t17 = dotproduct(k3, qshift)
      t18 = dotproduct(k6, qshift)
      t19 = dotproduct(k4, qshift)
      t20 = dotproduct(k5, qshift)
      if(deg.eq.0) then
         numerator = (abb16n17+t1*abb16n41+abb16n22*dotproduct(qshift, qshift)+a&
         &bb16n31*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshif&
         &t(3)-spvak5k1(4)*qshift(4))+abb16n32*(spvak6k1(1)*qshift(1)-spvak6k1(2&
         &)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*qshift(4))+abb16n36*(spv&
         &ak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k&
         &1(4)*qshift(4))+abb16n38*(spvak4k1(1)*qshift(1)-spvak4k1(2)*qshift(2)-&
         &spvak4k1(3)*qshift(3)-spvak4k1(4)*qshift(4))+abb16n40*dotproduct(k2, q&
         &shift)+t1*t17*abb16n27+t1*t18*abb16n27+t1*t19*abb16n28+t1*t2*abb16n18+&
         &t1*t20*abb16n28+t1*t3*abb16n19+t1*t4*abb16n24+t1*t5*abb16n26)
         return
      end if
      t6 = spvak2k1(iv1)
      t7 = k3(iv1)
      t8 = k4(iv1)
      t9 = k5(iv1)
      t10 = k6(iv1)
      t11 = t6*abb16n33
      t12 = t6*abb16n34
      t13 = spvak3k5(iv1)
      t14 = spvak3k6(iv1)
      t15 = spvak4k5(iv1)
      t16 = spvak4k6(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb16n21+qshift(iv1)*abb16n39+spvak3k1(iv1)*abb16n&
         &25+spvak4k1(iv1)*abb16n23+spvak5k1(iv1)*abb16n30+spvak6k1(iv1)*abb16n2&
         &9+t11*t19+t11*t20+t12*t17+t12*t18+t6*abb16n20+t1*t10*abb16n34+t1*t13*a&
         &bb16n37+t1*t14*abb16n35+t1*t15*abb16n42+t1*t16*abb16n43+t1*t7*abb16n34&
         &+t1*t8*abb16n33+t1*t9*abb16n33+t2*t6*abb16n43+t3*t6*abb16n42+t4*t6*abb&
         &16n37+t5*t6*abb16n35)
         return
      end if
      t1 = spvak2k1(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb16n22+k3(iv2)*t6*abb16n27+k4(iv2)*t&
         &6*abb16n28+k5(iv2)*t6*abb16n28+k6(iv2)*t6*abb16n27+spvak3k5(iv2)*t6*ab&
         &b16n24+spvak3k6(iv2)*t6*abb16n26+spvak4k5(iv2)*t6*abb16n19+spvak4k6(iv&
         &2)*t6*abb16n18+t1*t10*abb16n27+t1*t13*abb16n24+t1*t14*abb16n26+t1*t15*&
         &abb16n19+t1*t16*abb16n18+t1*t7*abb16n27+t1*t8*abb16n28+t1*t9*abb16n28)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d16:
   subroutine     reconstruct_d16(coeffs)
      use p0_ddbar_emnmumupnebar_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_16:
      coeffs%coeffs_16%c0 = derivative(czip)
      coeffs%coeffs_16%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_16%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_16%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_16%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_16%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_16%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_16%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_16%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_16%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_16%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_16%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_16%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_16%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_16%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_16:
   end subroutine reconstruct_d16
!---#] subroutine reconstruct_d16:
end module p0_ddbar_emnmumupnebar_d16h1l1d
