module     p0_ddbar_emnmumupnebar_d50h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/WpWm/1.4/Virtual/p0
   ! _ddbar_emnmumupnebar/helicity1/d50h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emnmumupnebar_config, only: ki
   use p0_ddbar_emnmumupnebar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d50
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p0_ddbar_emnmumupnebar_globalsl1, only: epspow
      use p0_ddbar_emnmumupnebar_kinematics
      use p0_ddbar_emnmumupnebar_abbrevh1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb50n11+abb50n12*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshif&
         &t(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb50n13*(spvak4k1(1&
         &)*qshift(1)-spvak4k1(2)*qshift(2)-spvak4k1(3)*qshift(3)-spvak4k1(4)*qs&
         &hift(4))+abb50n14*(spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k&
         &6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb50n15*dotproduct(k1, qshift)+&
         &abb50n16*dotproduct(k3, qshift)+abb50n16*dotproduct(k6, qshift)+abb50n&
         &17*(spvak4k6(1)*qshift(1)-spvak4k6(2)*qshift(2)-spvak4k6(3)*qshift(3)-&
         &spvak4k6(4)*qshift(4))+abb50n18*(spvak3k6(1)*qshift(1)-spvak3k6(2)*qsh&
         &ift(2)-spvak3k6(3)*qshift(3)-spvak3k6(4)*qshift(4))+abb50n19*(spvak3k1&
         &(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb50n15+k3(iv1)*abb50n16+k6(iv1)*abb50n16+spvak2k&
         &1(iv1)*abb50n12+spvak2k6(iv1)*abb50n14+spvak3k1(iv1)*abb50n19+spvak3k6&
         &(iv1)*abb50n18+spvak4k1(iv1)*abb50n13+spvak4k6(iv1)*abb50n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d50:
   subroutine     reconstruct_d50(coeffs)
      use p0_ddbar_emnmumupnebar_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_50:
      coeffs%coeffs_50%c0 = derivative(czip)
      coeffs%coeffs_50%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_50%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_50%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_50%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_50:
   end subroutine reconstruct_d50
!---#] subroutine reconstruct_d50:
end module p0_ddbar_emnmumupnebar_d50h1l1d
