module     p0_ddbar_emnmumupnebar_diagramsh1l0
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/WpWm/1.4/Virtual/p0
   ! _ddbar_emnmumupnebar/helicity1/diagramsl0.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emnmumupnebar_color, only: numcs
   use p0_ddbar_emnmumupnebar_config, only: ki
   implicit none

   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki

   public :: amplitude

contains
   function     amplitude()
      use p0_ddbar_emnmumupnebar_model
      use p0_ddbar_emnmumupnebar_kinematics
      use p0_ddbar_emnmumupnebar_color
      use p0_ddbar_emnmumupnebar_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use p0_ddbar_emnmumupnebar_accu, only: sorted_sum
      use p0_ddbar_emnmumupnebar_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(9,numcs) :: diagrams
      integer :: i
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      real(ki) :: t8
      real(ki) :: t9
      real(ki) :: t10
      real(ki) :: t11
      diagrams(:,:) = (0.0_ki, 0.0_ki)
      t8 = mW*mW
      t1 = i_*mW*wW
      t2 = t1+es45-t8
      t9 = es12-es123
      t1 = t1+t9+es45-(es345+t8)
      t3 = spak1k3*spbk5k1*spbk6k1
      t8 = gW*gW
      t10 = t8*t8
      t4 = (es45+es61-(es345+es23))*t1*t2
      diagrams(9, :) = (spak2k4*i_*(4.0_ki)*(t10*t3/t4-t10/t4*spak3k6*spbk6k1*sp&
      &bk6k5)*c1)
      t4 = es12+i_*mZ*wZ-mZ*mZ
      t10 = gDl*gnel
      t5 = t2*t4
      t6 = t5*es345
      diagrams(8, :) = (spak3k4*i_*(4.0_ki)*(t10/t6*t8*spak2k6*spbk6k1*spbk6k5-t&
      &10/t6*t8*spak1k2*spbk5k1*spbk6k1)*c1)
      t10 = gDl*gel
      t6 = t5*es123
      diagrams(7, :) = (spak2k3*i_*(4.0_ki)*(t10/t6*t8*spak2k4*spbk2k1*spbk6k5-t&
      &10/t6*t8*spak3k4*spbk3k1*spbk6k5)*c1)
      t6 = t2*es12*es123
      diagrams(6, :) = (spak2k3*i_*(4.0_ki/3.0_ki)*(t8/t6*spak2k4*spbk2k1*spbk6k&
      &5-t8/t6*spak3k4*spbk3k1*spbk6k5)*c1)
      t10 = es12+es34-(es56+es345)
      t11 = gDl*gmul
      t6 = t1*t10*t4
      diagrams(5, :) = (spak3k4*i_*(4.0_ki)*(t11/t6*t8*spak1k2*spbk5k1*spbk6k1+t&
      &11/t6*t8*spak2k5*spbk5k1*spbk6k5)*c1)
      t6 = t1*t10*es12
      t7 = t8*spak2k5*spbk5k1*spbk6k5
      diagrams(4, :) = (spak3k4*i_*(4.0_ki/3.0_ki)*(t7/t6+t8/t6*spak1k2*spbk5k1*&
      &spbk6k1)*c1)
      t10 = gDl*gnmul
      t4 = (t9+es56-es34)*t1*t4
      diagrams(3, :) = (spak2k4*i_*(4.0_ki)*(-(t10/t4*t8*spak3k4*spbk4k1*spbk6k5&
      &+t10/t4*t8*spak2k3*spbk2k1*spbk6k5))*c1)
      t9 = gDl*gWWZ
      t4 = t1*t5
      t5 = t9*spbk5k1
      diagrams(2, :) = (i_*(2.0_ki)*((t8/t4*t9*spak2k5*spbk5k1*spbk6k5-t8/t4*t9*&
      &spak2k6*spbk6k1*spbk6k5)*spak3k4+((t8/t4*t9*spbk4k1*spbk6k5-t5/t4*t8*spbk&
      &6k4)*spak3k4+t8/t4*t9*spak1k3*spbk5k1*spbk6k1-t8/t4*t9*spak3k5*spbk5k1*sp&
      &bk6k5)*spak2k4+((t5/t4*t8*spbk6k2-t8/t4*t9*spbk5k2*spbk6k1)*spak2k4+(-(t8&
      &/t4*t9*spbk5k3*spbk6k1+t8/t4*t9*spbk3k1*spbk6k5))*spak3k4-(t8/t4*t9*spak4&
      &k6*spbk6k1*spbk6k5+t8/t4*t9*spak1k4*spbk5k1*spbk6k1))*spak2k3)*c1)
      t1 = t1*t2*es12
      diagrams(1, :) = (i_*(2.0_ki/3.0_ki)*((t7/t1-t8/t1*spak2k6*spbk6k1*spbk6k5&
      &)*spak3k4+((t8/t1*spbk4k1*spbk6k5-t8/t1*spbk5k1*spbk6k4)*spak3k4+t3/t1*t8&
      &-t8/t1*spak3k5*spbk5k1*spbk6k5)*spak2k4+((-(t8/t1*spbk5k3*spbk6k1+t8/t1*s&
      &pbk3k1*spbk6k5))*spak3k4+(t8/t1*spbk5k1*spbk6k2-t8/t1*spbk5k2*spbk6k1)*sp&
      &ak2k4-(t8/t1*spak4k6*spbk6k1*spbk6k5+t8/t1*spak1k4*spbk5k1*spbk6k1))*spak&
      &2k3)*c1)
      if (debug_lo_diagrams) then
         call inspect_lo_diagram(diagrams(1,:), 1, 1, 19)
         call inspect_lo_diagram(diagrams(2,:), 2, 1, 19)
         call inspect_lo_diagram(diagrams(3,:), 3, 1, 19)
         call inspect_lo_diagram(diagrams(4,:), 4, 1, 19)
         call inspect_lo_diagram(diagrams(5,:), 5, 1, 19)
         call inspect_lo_diagram(diagrams(6,:), 6, 1, 19)
         call inspect_lo_diagram(diagrams(7,:), 7, 1, 19)
         call inspect_lo_diagram(diagrams(8,:), 8, 1, 19)
         call inspect_lo_diagram(diagrams(9,:), 9, 1, 19)
      end if

      if (use_sorted_sum) then
         do i=1,numcs
            amplitude(i) = sorted_sum(diagrams(:,i))
         end do
      else
         do i=1,numcs
            amplitude(i) = sum(diagrams(:,i))
         end do
      end if
   end function     amplitude
end module p0_ddbar_emnmumupnebar_diagramsh1l0
